unit EnumPort; //based on stripped code

interface
uses SysUtils,Windows,Registry,Classes;

procedure EnumComms(ss:TStrings);

implementation

procedure EnumComms(ss:TStrings);
const
 szKey='HARDWARE\DEVICEMAP\SERIALCOMM';
var
 hSERIALCOMM:HKEY;
 dwMaxValueNameLen:DWORD;
 dwMaxValueLen:DWORD;
 dwQueryInfo:DWORD;
 dwMaxValueNameSizeInChars:DWORD;
 dwMaxValueNameSizeInBytes:DWORD;
 dwMaxValueDataSizeInChars:DWORD;
 dwMaxValueDataSizeInBytes:DWORD;
 dwIndex          :DWORD;
 dwType           :DWORD;
 dwValueNameSize  :DWORD;
 dwDataSize       :DWORD;
 nEnum:DWORD;
 szValueName:String;
 byValue:array of Byte;
begin
 hSERIALCOMM:=0;
 while True do begin
 if (RegOpenKeyEx(HKEY_LOCAL_MACHINE,szKey,0,KEY_QUERY_VALUE,hSERIALCOMM)<>ERROR_SUCCESS) then Break;
  dwQueryInfo:=RegQueryInfoKey(hSERIALCOMM,nil,nil,nil,nil,nil,nil,nil,@dwMaxValueNameLen,@dwMaxValueLen,nil,nil);
	if dwQueryInfo <> ERROR_SUCCESS then Break;
  dwMaxValueNameSizeInChars:= dwMaxValueNameLen + 1;
  dwMaxValueNameSizeInBytes:= dwMaxValueNameSizeInChars * sizeof(CHAR);
  dwMaxValueDataSizeInChars:= dwMaxValueLen div sizeof(CHAR) + 1;
	dwMaxValueDataSizeInBytes:= dwMaxValueDataSizeInChars * sizeof(CHAR);
  SetLength(szValueName,dwMaxValueNameSizeInBytes);
  SetLength(byValue,dwMaxValueDataSizeInBytes);
  dwIndex:= 0;
	dwValueNameSize:= dwMaxValueNameSizeInChars;
	dwDataSize:= dwMaxValueDataSizeInBytes;
  ZeroMemory(PChar(szValueName),Length(szValueName)*sizeof(CHAR));
  ZeroMemory(PByte(byValue),Length(byValue));
	nEnum:= RegEnumValue(hSERIALCOMM,dwIndex,PChar(szValueName),dwValueNameSize,nil,@dwType,PByte(byValue),@dwDataSize);
	while nEnum = ERROR_SUCCESS do begin
	 if dwType = REG_SZ then ss.Add(PChar(byValue));
   dwValueNameSize:=dwMaxValueNameSizeInChars;
	 dwDataSize:=dwMaxValueDataSizeInBytes;
   ZeroMemory(PChar(szValueName),Length(szValueName)*sizeof(CHAR));
   ZeroMemory(PByte(byValue),Length(byValue));
	 Inc(dwIndex);
	 nEnum:=RegEnumValue(hSERIALCOMM,dwIndex,PChar(szValueName),dwValueNameSize,nil,@dwType,PByte(byValue),@dwDataSize);
	end;
  Break;
 end;
 if hSERIALCOMM<>0 then RegCloseKey(hSERIALCOMM);
end;
end.
