unit SelfSave;

interface
 uses SysUtils,Classes;


type TSelfSave = class
 fSelfFileName  :string;
 fOffsets: PInteger;
 procedure SelfLoad(FileName:string);
 procedure SelfSave;
end;

implementation

{ TSelfSave }

procedure TSelfSave.SelfLoad(FileName:string);
var
 FileStream: TFileStream;
 l,r: Integer;
 p:Pointer; iptr:PInteger;
 ps:^string;
begin
 fSelfFileName:=FileName;
 iptr:=fOffsets;
 if not FileExists(fSelfFileName) then SelfSave;
 FileStream := TFileStream.Create(fSelfFileName, fmOpenRead);
 try while True do begin
  r:=iptr^;
  p:=Pointer(Integer(Self)+r);
  Inc(iptr);
  l:=iptr^;
  Inc(iptr);
  if (l=0) and (r=0) then break;
  if l>0 then
   FileStream.Read(p^,l)
  else begin
   FileStream.Read(l,4);
   ps:=p;
   if l>0 then begin
    SetLength(ps^,l div sizeof(Char));
    FileStream.Read(ps^[1],l);
   end;
  end;
 end; finally FileStream.Free; end;
end;

procedure TSelfSave.SelfSave;
var
  FileStream:  TFileStream;
  l,r: Integer;
  p:Pointer; iptr:PInteger;
  ps:^string;
begin
 iptr:=fOffsets;
 FileStream := TFileStream.Create(fSelfFileName, fmCreate);
 try while True do begin
  r:=iptr^;
  p:=Pointer(Integer(Self)+r);
  Inc(iptr);
  l:=iptr^;
  Inc(iptr);
  if (l=0) and (r=0) then break;
  if l>0 then
   FileStream.Write(p^,l)
  else begin
   ps:=p;
   l:=Length(ps^)*sizeof(Char);
   FileStream.Write(l,4);
   if l>0 then FileStream.Write(ps^[1],l);
  end;
 end; finally FileStream.Free; end;
end;


end.

