unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls,
  Config,  BinTools, UartLaer, EnumPort;

const
  WM_COMMINFO = WM_USER+101;

type
  TForm1 = class(TForm)
    Panel2: TPanel;
    Splitter1: TSplitter;
    Panel3: TPanel;
    Splitter2: TSplitter;
    Mm1: TMemo;
    Panel1: TPanel;
    Ed1: TEdit;
    CbA1: TCheckBox;
    CbS1: TCheckBox;
    CbR1: TCheckBox;
    Panel4: TPanel;
    Ed2: TEdit;
    CbA2: TCheckBox;
    CbS2: TCheckBox;
    CbR2: TCheckBox;
    Mc2: TMemo;
    Mc1: TMemo;
    Splitter3: TSplitter;
    Mm2: TMemo;
    Sb2: TEdit;
    CbH1: TCheckBox;
    CbH2: TCheckBox;
    CbL1: TCheckBox;
    CbL2: TCheckBox;
    Timer1: TTimer;
    Cb2: TComboBox;
    Button1: TButton;
    Panel5: TPanel;
    CbRING2: TCheckBox;
    CbRLSD2: TCheckBox;
    CbDSR2: TCheckBox;
    CbCTS2: TCheckBox;
    CbDTR2: TCheckBox;
    CbRTS2: TCheckBox;
    Panel6: TPanel;
    Sb1: TEdit;
    CbRING1: TCheckBox;
    CbRLSD1: TCheckBox;
    CbDSR1: TCheckBox;
    CbCTS1: TCheckBox;
    CbDTR1: TCheckBox;
    CbRTS1: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure Mc2KeyPress(Sender: TObject; var Key: Char);
    procedure Mc2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Ed1KeyPress(Sender: TObject; var Key: Char);
    procedure Ed1DblClick(Sender: TObject);
    procedure Ed1Change(Sender: TObject);
    procedure CbA1Click(Sender: TObject);
    procedure CbS1Click(Sender: TObject);
    procedure CbR2Click(Sender: TObject);
    procedure CbH1Click(Sender: TObject);
    procedure Mm1DblClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CbL1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Cb2CloseUp(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Panel4DblClick(Sender: TObject);
    procedure CbRTS2Click(Sender: TObject);
    procedure CbDTR1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Splitter1Moved(Sender: TObject);
  private
    procedure SendCommInfo(w,l:DWORD);
    procedure  UpdateReport;
    { Private declarations }
  public
    function  CommEvent(pComm:TUartLaer; Event:TUartEvent):DWORD;
    procedure WmCommInfo(var Msg:TMessage); message WM_COMMINFO;
    procedure WmSysCmd (var Msg:TMessage);  message WM_SYSCOMMAND;
    procedure WmDevChg (var Msg:TMessage);  message WM_DEVICECHANGE;

    { Public declarations }
  end;

type TTR=record
  Tm:Cardinal;
  Bt:Cardinal;
 end;

var
  Form1: TForm1;
  Tb1,Tb2:TTR;
var
 Comm1,Comm2:TUartLaer;
implementation

{$R *.dfm}

procedure TForm1.CbA1Click(Sender: TObject);
var
 Cfg:TCfg;
 Cb:TCheckBox;
begin
 Cb:=Sender as TCheckBox;
 case Cb.Tag of
  1: Cfg:=Cfg1;
  2: Cfg:=Cfg2;
  else exit;
 end;
 if Cb.Checked then Cfg.AutoOpen:=1
               else Cfg.AutoOpen:=0;
end;

procedure TForm1.CbDTR1Click(Sender: TObject);
var
 p:Cardinal;
begin
 p:=0;
 if CbRTS1.Checked then p:=p or pinRTS;
 if CbDTR1.Checked then p:=p or pinDTR;
 Comm1.Pin:=p;
end;

procedure TForm1.CbH1Click(Sender: TObject);
var
 Cfg:TCfg;
 Cb:TCheckBox;
begin
 Cb:=Sender as TCheckBox;
 case Cb.Tag of
  1: Cfg:=Cfg1;
  2: Cfg:=Cfg2;
  else exit;
 end;
 Cfg.HexOut:=DWORD(Cb.State);
end;

procedure TForm1.CbL1Click(Sender: TObject);
var
 Cfg:TCfg;
 Cb:TCheckBox;
begin
 Cb:=Sender as TCheckBox;
 case Cb.Tag of
  1: Cfg:=Cfg1;
  2: Cfg:=Cfg2;
  else exit;
 end;
 Cfg.AddLn:=DWORD(Cb.State);
end;

procedure TForm1.CbR2Click(Sender: TObject);
var
 Cfg:TCfg;
 Cb:TCheckBox;
begin
 Cb:=Sender as TCheckBox;
 case Cb.Tag of
  1: Cfg:=Cfg1;
  2: Cfg:=Cfg2;
  else exit;
 end;
 if Cb.Checked then Cfg.Redirect:=1
               else Cfg.Redirect:=0;
end;

procedure TForm1.CbRTS2Click(Sender: TObject);
var
 p:Cardinal;
begin
 p:=0;
 if CbRTS2.Checked then p:=p or pinRTS;
 if CbDTR2.Checked then p:=p or pinDTR;
 Comm2.Pin:=p;
end;

procedure TForm1.CbS1Click(Sender: TObject);
var
 Cfg:TCfg;
 Cb:TCheckBox;
begin
 Cb:=Sender as TCheckBox;
 case Cb.Tag of
  1: Cfg:=Cfg1;
  2: Cfg:=Cfg2;
  else exit;
 end;
 if Cb.Checked then Cfg.SaveCmd:=1
               else Cfg.SaveCmd:=0;
end;

// To test ReadT function (Timeout Read)
// (it is not recommended for strong use )
//
procedure TForm1.Button1Click(Sender: TObject);
const
 cc=512;
var
 l,t:Cardinal;
 b:array [0..cc-1] of Byte;
 sa:AnsiString;
 pKey:Char;
begin
 Comm2.AutoRead:=False;
 t:=GetTickCount;
 pKey:=#13;
 Mc2KeyPress(Mc2,pKey);
 Mm2.Lines.Add('------------------------ Send Line And Start ReadT: '+InttoStr(t));
 l:=Comm2.Readt(PByte(@b[0]),cc,10000);
 if l>0 then begin
  if cc<l then l:=cc;
  b[l-1]:=0;
  sa:=PAnsiChar(PByte(@b[0]));
  Mm2.Lines.Add(sa);
 end;
 Mm2.Lines.Add(':::::::::::::::::::::::: Bytes ReadT: '+InttoStr(l));
 Mm2.Lines.Add('------------------------ Print Line ^ And End ReadT: '+InttoStr(GetTickCount-t)+' ms');
 Comm2.AutoRead:=True;
end;
//

procedure TForm1.Cb2CloseUp(Sender: TObject);
begin
 Ed2.Text:=LowerCase(Cb2.Items[Cb2.ItemIndex]);
 Ed2.SetFocus;
end;

function TForm1.CommEvent(pComm: TUartLaer; Event:TUartEvent): DWORD;
begin
 SendCommInfo(Cardinal(Event),pComm.Tag);
 Result:=0;
end;

procedure TForm1.Ed1Change(Sender: TObject);
var
 Cfg:TCfg;
 Ed:TEdit;
begin
 Ed:=Sender as TEdit;
 case Ed.Tag of
  1: Cfg:=Cfg1;
  2: Cfg:=Cfg2;
  else exit;
 end;
 Cfg.sComm:=Ed.Text;
end;

procedure TForm1.Ed1DblClick(Sender: TObject);
var
 key:Char;
begin
 if GetAsyncKeyState(VK_CONTROL)>0
  then key:=#10
  else key:=#13;
 Ed1KeyPress(Sender,key);
end;

procedure TForm1.Ed1KeyPress(Sender: TObject; var Key: Char);
var
 Ed:TEdit;
 Comm:TUartLaer;
 Cfg:TCfg;
 pCfg:Pointer;
begin
 if (key=#13) or (key=#10) then
 begin
  Ed:=Sender as TEdit;
  case Ed.Tag of
   1:begin Comm:=Comm1; Cfg:=Cfg1; end;
   2:begin Comm:=Comm2; Cfg:=Cfg2; end;
   else Exit;
  end;
  if Cfg.CommCfg.dwSize>0 then pCfg:=@Cfg.CommCfg
                          else pCfg:=nil;
  if key=#13 then begin
   if (Ed.Font.Style=[fsBold]) then Comm.Close
                               else Comm.Open(PChar(Cfg.sComm),pCfg);
  end;
  if key=#10 then begin
    Comm.GuiCfg(nil);
    CopyMemory(@Cfg.CommCfg,@Comm.Cfg,sizeof(Cfg.CommCfg));
  end;
  key:=#0;
 end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Cfg1.wpCmd1:=Mc1.Height;
 Cfg1.wpCmd2:=Mc2.Height;
 Cfg1.wpTopa:=Form1.Top;
 Cfg1.wpLeft:=Form1.Left;
 Cfg1.wpHigh:=Form1.Height;
 Cfg1.wpLong:=Form1.Width;
 Cfg1.wpWnd1:=Panel2.Width;

 if Cfg1.SaveCmd>0 then Mc1.Lines.SaveToFile(GetCurrentDir+PathDelim+sfCmd[1]);
 if Cfg2.SaveCmd>0 then Mc2.Lines.SaveToFile(GetCurrentDir+PathDelim+sfCmd[2]);

 Comm2.Free;
 Comm1.Free;

 Cfg1.Free;
 Cfg2.Free;
 FreeMem(TCfg.pOffsets);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
 key:Char;
begin
 Cfg1 :=TCfg.Create(GetCurrentDir+PathDelim+sfCfg[1]);
 Cfg2 :=TCfg.Create(GetCurrentDir+PathDelim+sfCfg[2]);

 //Cfg1.wpInit:=0;
 if Cfg1.wpInit<>0 then begin
  Panel2.Visible:=Cfg1.wpOnl2<>0;
  Form1.Top   :=Cfg1.wpTopa;
  Form1.Left  :=Cfg1.wpLeft;
  Form1.Height:=Cfg1.wpHigh;
  Form1.Width :=Cfg1.wpLong;
  Mc1.Height  :=Cfg1.wpCmd1;
  Mc2.Height  :=Cfg1.wpCmd2;
  Panel2.Width:=Cfg1.wpWnd1;
 end else Cfg1.wpInit:=1;
 Panel2.Tag:=Panel2.Width;
 Panel4.Tag:=Form1.ClientWidth;

 Comm1:=TUartLaer.Create(Form1,@TForm1.CommEvent);
 Comm2:=TUartLaer.Create(Form1,@TForm1.CommEvent);
 Comm1.Tag:=1;
 Comm2.Tag:=2;

 CbH1.State:=TCheckBoxState(Cfg1.HexOut);
 CbH2.State:=TCheckBoxState(Cfg2.HexOut);
 CbA1.Checked := Cfg1.AutoOpen>0;
 CbA2.Checked := Cfg2.AutoOpen>0;
 CbS1.Checked := Cfg1.SaveCmd>0;
 CbS2.Checked := Cfg2.SaveCmd>0;
 CbR1.Checked := Cfg1.Redirect>0;
 CbR2.Checked := Cfg2.Redirect>0;
 CbL1.Checked := Cfg1.AddLn>0;
 CbL2.Checked := Cfg2.AddLn>0;

 Ed1.Text:=Cfg1.sComm;
 Ed2.Text:=Cfg2.sComm;

 key:=#13; if Cfg1.AutoOpen>0 then Ed1KeyPress(Ed1,key);
 key:=#13; if Cfg2.AutoOpen>0 then Ed1KeyPress(Ed2,key);

 if Cfg1.SaveCmd>0 then Mc1.Lines.LoadFromFile(GetCurrentDir+PathDelim+sfCmd[1]);
 if Cfg2.SaveCmd>0 then Mc2.Lines.LoadFromFile(GetCurrentDir+PathDelim+sfCmd[2]);

 EnumComms(Cb2.Items);
 Cb2.Text:='Comms';

 AppendMenu(GetSystemMenu(Handle,FALSE),MF_SEPARATOR,SC_SEPARATOR,nil);
 AppendMenu(GetSystemMenu(Handle,FALSE),MF_SEPARATOR,SC_SEPARATOR,nil);
 AppendMenu(GetSystemMenu(Handle,FALSE),MF_STRING ,$1100,' v2 tools ');
 AppendMenu(GetSystemMenu(Handle,FALSE),MF_SEPARATOR,SC_SEPARATOR,nil);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
 if Panel2.Tag<>0 then
  Panel2.Width:=Round(Form1.ClientWidth * (Panel2.Tag/Panel4.Tag));
 Panel2.Tag:=Panel2.Width;
 Panel4.Tag:=Form1.ClientWidth;
end;

procedure TForm1.Mc2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
 pKey:Char;
begin
 if (Key=VK_RETURN) and (ssAlt in Shift) then begin
  pKey:=#13;
  Mc2KeyPress(Sender,pKey);
 end;
end;

procedure TForm1.Mc2KeyPress(Sender: TObject; var Key: Char);
var
 s:string;
 ln,len:Integer;
 hMemo:HWND;
 Memo:TMemo;
 buff:PByte;
 crc :Word;
 Comm:TUartLaer;
begin
if (Key=#13) or (Key=#10) then begin
 if (GetKeyState(VK_CONTROL)<0) or (GetKeyState(VK_SHIFT)<0) or (GetKeyState(VK_MENU)<0) then begin
  Memo:=Sender as TMemo;
  case Memo.Tag of
   1:Comm:=Comm1;
   2:Comm:=Comm2;
   else exit;
  end;
  hMemo:=Memo.Handle;
  ln:=SendMessage(hMemo,EM_LINEFROMCHAR,HiWord(SendMessage(hMemo,EM_GETSEL,0,0)),0);
  s:=Memo.Lines[ln];
  len:=HexStr2Bin(s,buff);
  Key:=#0;
  if (GetKeyState(VK_MENU)<0) then begin
   crc:=CallCRC(buff,len);
   s:=s+'\'+inttohex(crc shr 8,2)+'\'+inttohex(crc and $00FF,2);
   Memo.Lines[ln]:=s;
   FreeMem(buff);
   Exit;
  end;
  if (GetKeyState(VK_SHIFT)<0) then begin
   PWord(Integer(buff)+len)^:=$0A0D;
   len:=len+2;
  end;
  if (GetKeyState(VK_CONTROL)<0)or(GetKeyState(VK_SHIFT)<0) then begin
   Comm.Write(buff,len);
   FreeMem(buff);
  end;
 end;
end;
end;

procedure TForm1.Mm1DblClick(Sender: TObject);
var
 Me:TMemo;
 s:string;
begin
 Me:=TMemo(Sender);
 s:=GetCurrentDir+PathDelim+sfLog[Me.Tag];
 if Me.Lines.Count>0 then begin
  Me.Lines.SaveToFile(s);
  Me.Clear;
 end else
  Me.Lines.LoadFromFile(s);
end;

procedure TForm1.Panel4DblClick(Sender: TObject);
begin
 Panel2.Visible:=not Panel2.Visible;
 Cfg1.wpOnl2:=Integer(Panel2.Visible);
end;

procedure TForm1.SendCommInfo(w, l: DWORD);
begin
 SendMessage(Form1.Handle,WM_COMMINFO,w,l);
end;

procedure TForm1.Splitter1Moved(Sender: TObject);
begin
 Panel2.Tag:=Panel2.Width;
 Panel4.Tag:=Form1.ClientWidth;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 UpdateReport;
end;

procedure TForm1.UpdateReport;
 function urstr(b:Cardinal):string;
 begin
  Result:='----------------------------------------------------- '+TimeToStr(Now)+' rx: '+inttostr(b)+' ;'+#13+#10;
 end;
const
 dt=1000;
var
 t:Cardinal;
 s:string;
begin
 t:=GetTickCount;
 if (t-Tb1.Tm>dt) and (Tb1.Bt<>0) then begin
  Mm1.Lines.Add(urstr(Tb1.Bt));
  Tb1.Bt:=0;
  Tb1.Tm:=t;
 end ;
 if (t-Tb2.Tm>dt) and (Tb2.Bt<>0) then begin
  Mm2.Lines.Add(urstr(Tb2.Bt));
  Tb2.Bt:=0;
  Tb2.Tm:=t;
 end ;
end;

procedure TForm1.WmCommInfo(var Msg: TMessage);
var
 Comm,ToComm:TUartLaer;
 Ed,Sb:TEdit;
 Mm:TMemo;
 Cfg:TCfg;
 s:string;
 Tb:^TTR;
 CbRTS :TCheckBox;
 CbDTR :TCheckBox;
 CbCTS :TCheckBox;
 CbDSR :TCheckBox;
 CbRING:TCheckBox;
 CbRLSD:TCheckBox;
begin
 case msg.LParam of
  1: begin
      Comm:=Comm1; ToComm:=Comm2; Cfg:=Cfg1; Ed:=Ed1; Mm:=Mm1; Sb:=Sb1; Tb:=@Tb1;
      CbCTS:=CbCTS1; CbDSR:=CbDSR1; CbRING:=CbRING1; CbRLSD:=CbRLSD1; CbRTS:=CbRTS1; CbDTR:=CbDTR1;
     end;
  2: begin
      Comm:=Comm2; ToComm:=Comm1; Cfg:=Cfg2; Ed:=Ed2; Mm:=Mm2; Sb:=Sb2; Tb:=@Tb2;
      CbCTS:=CbCTS2; CbDSR:=CbDSR2; CbRING:=CbRING2; CbRLSD:=CbRLSD2; CbRTS:=CbRTS2; CbDTR:=CbDTR2;
     end;
  else Exit;
 end;
 case TUartEvent(msg.WParam) of
  evState :begin
            Sb.Text:='Pin Changed';
            CbCTS.Checked :=Boolean(Comm.Stat and pinCTS);
            CbDSR.Checked :=Boolean(Comm.Stat and pinDSR);
            CbRING.Checked:=Boolean(Comm.Stat and pinRING);
            CbRLSD.Checked:=Boolean(Comm.Stat and pinRLSD);
           end;
  evRead  :begin
             Comm.Buff[Comm.RxLen]:=0;
             case Cfg.HexOut of
              DWORD(cbUnchecked): s:=strpas(PAnsiChar(Comm.Buff));
              DWORD(cbChecked)  : s:=Bin2HexStr(Pointer(Comm.Buff),Comm.RxLen,Boolean(Cfg.AddLn));
              DWORD(cbGrayed)   : s:=Bin2HexStrEx(Pointer(Comm.Buff),Comm.RxLen,Boolean(Cfg.AddLn));
             end;
             if Cfg.AddLn<>0 then s:=s+#13+#10;
             Tb.Tm:=GetTickCount;
             Inc(Tb.Bt,Comm.RxLen);
             SendMessage(Mm.Handle,EM_SETSEL,-1,-1);
             SendMessage(Mm.Handle,EM_REPLACESEL,0,DWORD(PChar(s)));
            Sb.Text:='rx: '+inttostr(Comm.RxLen)+'  Rx:'+InttoStr(Comm.Rxed)+' Tx:'+InttoStr(Comm.Txed);
            if Cfg.Redirect<>0 then
             ToComm.Write(Comm.Buff,Comm.RxLen);
            Comm.Len:=0;
           end;
  evWrite :begin
            Sb.Text:='tx: '+inttostr(Comm.TxLen)+'  Rx:'+InttoStr(Comm.Rxed)+' Tx:'+InttoStr(Comm.Txed);
           end;
  evOpen  :begin
            Sb.Text:='Opened';
            Ed.Font.Style:=[fsBold];
            CbRTS.Enabled:=True;
            CbDTR.Enabled:=True;
            CbRTS.Checked:=True;
            CbDTR.Checked:=True;
            if Comm.Tag=2 then Cb2.Enabled:=False;
           end;
  evClose :begin
            Sb.Text:='Closed';
            Ed.Font.Style:=[];
            CbRTS.Enabled:=False;
            CbDTR.Enabled:=False;
            CbRTS.Checked:=False;
            CbDTR.Checked:=False;
            if Comm.Tag=2 then Cb2.Enabled:=True;
           end;
  evBreak :begin
            Sb.Text:='Break';
            Ed.Font.Style:=[];
            CbRTS.Enabled:=False;
            CbDTR.Enabled:=False;
            CbRTS.Checked:=False;
            CbDTR.Checked:=False;
            if Comm.Tag=2 then Cb2.Enabled:=True;
           end;
  evError :begin Sb.Text:='Error: '+Comm.StrErr+'('+inttostr(Comm.Err)+')'; end;
 end;
end;

procedure TForm1.WmDevChg(var Msg: TMessage);
begin
// if GetTickCount-Cb2.Tag>1000 then begin
//  Cb2.Tag:=GetTickCount;
  Cb2.Items.Clear;
  EnumComms(Cb2.Items);
  Cb2.Text:='Comms';
  Msg.Result:=1;
// end;
end;

procedure TForm1.WmSysCmd(var Msg: TMessage);
begin
 if Msg.WParam=$1100 then begin
  Windows.Beep(2000,250);
  Caption:=Caption+' v2@nm.ru';
  Msg.Result:=0;
 end else inherited; //:)
end;

end.


